angular.module('ngApp').controller('FormsCtrl', function($scope, $timeout, $ionicPopup, $stateParams, ionicDatePicker, ionicTimePicker) {

    $scope.fileChange = function (files, field)
    {
        if (files != null)
        {
            var file = files[0];
            if (window.FileReader != null && typeof file != "undefined" && typeof file.type != "undefined")
            {
                if(file.size < 10*1024*1024){
                    $timeout(function() {
                        var fileReader = new FileReader();
                        fileReader.readAsDataURL(file); // convert the image to data url.
                        fileReader.onload = function(e) {
                            $timeout(function() {
                                $("#" + field + "_file").html(e.target.result);
                                var nameInput = $("#" + field + "_name");
                                nameInput.val(file.name);
                                nameInput.trigger('input');
                                nameInput.trigger('change');
                                if(file.type.indexOf('image') > -1){
                                    $("#" + field + "_btn").addClass('fill').removeClass('video pdf other audio').css('background-image','url('+ e.target.result +')');
                                }else if(file.type.indexOf('audio') > -1){
                                    $("#" + field + "_btn").addClass('fill audio').removeClass('video pdf other').css('background-image','none');
                                }else if(file.type.indexOf('video') > -1){
                                    $("#" + field + "_btn").addClass('fill video').removeClass('audio pdf other').css('background-image','none');
                                }else if(file.type.indexOf('pdf') > -1){
                                    $("#" + field + "_btn").addClass('fill pdf').removeClass('video audio other').css('background-image','none');
                                }else{
                                    $("#" + field + "_btn").addClass('fill other').removeClass('video pdf audio').css('background-image','none');
                                }
                            });
                        }
                    });
                }
                else{
                    $("#" + field).val('');
                    $ionicPopup.alert({
                        title: lang('forms.error'),
                        template: lang('forms.maximum_file_size'),
                        okText: lang('forms.close')
                    });
                }

            }
            else {
                $("#" + field + "_btn").removeClass('fill video pdf other audio').css('background-image','none');
                $("#" + field + "_name").val('');
                $("#" + field + "_file").val('');
                $ionicPopup.alert({
                    title: lang('forms.error'),
                    template: lang('forms.file_not_valid'),
                    okText: lang('forms.close')
                });
            }
        }
    };

    if($stateParams.search){
        document.getElementById("searchable").innerHTML = doHighlight(document.getElementById("searchable").innerHTML,$stateParams.search);
    }


    var datevalue = false, timevalue = false;
    $scope.openDatePicker = function(model, time){
      ionicDatePicker.openDatePicker({
        callback: function (unix, dateString) {
          datevalue = unix;
          $scope[model] = dateString;
          if(time) {
            ionicTimePicker.openTimePicker({
              callback: function (val) {
                timevalue = val;
                var selectedTime = typeof (val) === 'undefined' ? new Date() : new Date(val * 1000);
                $scope[model] = dateString + ' - ' + selectedTime.getUTCHours() + ':' + selectedTime.getUTCMinutes();
              },
              inputTime: timevalue != false ? timevalue : (new Date()).getHours() * 60 * 60,
            });
          }
        },
        inputDate: datevalue != false ? new Date(datevalue) : new Date(),
      });
    };
    
    $scope.openTimePicker = function(model){
        ionicTimePicker.openTimePicker({
            callback: function (val) {
                timevalue = val;
                var selectedTime = typeof (val) === 'undefined' ? new Date() : new Date(val * 1000);
                $scope[model] = selectedTime.getUTCHours() + ':' + selectedTime.getUTCMinutes();
            },
            inputTime: timevalue != false ? timevalue : (new Date()).getHours() * 60 * 60,
        });
    };

});
