angular.module('ngApp').requires.push('leaflet-directive');
angular.module('ngApp').controller('MapCtrl', ['$scope', '$http', 'leafletData', function($scope, $http, leafletData) {

	angular.extend($scope, {
		map: {
			markers: [],
			route: false,
			defaults: {
				scrollWheelZoom: true,
				doubleClickZoom: true,
				attributionControl: false,
				zoomControl: true,
				zoomControlPosition: 'bottomleft',
				tileLayer: 'https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png',
			},
			center: {}
		}
	});

	// Wait until the var is init
	$scope.$watch('sl', function() {
		$scope.addMarkers();
	});

	$scope.addMarkers = function() {
		$http.get(url + '/api/v1/widget/get/map/getMarkers?sl=' + $scope.sl).then(function(resp) {
			var data = resp.data;
			var message, marker;
			if (data.markers.length > 0)
			{
				for (var i = data.markers.length - 1; i >= 0; i--)
				{
					message = '<h4>' + data.markers[i].title + '</h4>' + data.markers[i].content;
					if (typeof data.markers[i].link != "undefined" && data.markers[i].link != '')
						message += '<br><br><br><a class="button button-outline button-positive" href="' + data.markers[i].link + '"' + data.markers[i].linkTarget + '>' + data.markers[i].linkTitle + '</a>';
					marker = {
						lat: parseFloat(data.markers[i].latitude),
						lng: parseFloat(data.markers[i].longitude),
						message: message
					};
					if (data.markers[i].iconUrl != null) {
						marker.icon = {
							iconUrl: data.markers[i].iconUrl,
							iconSize: data.markers[i].iconSize,
						};
					} 
					$scope.map.markers.push(marker);
				}

				leafletData.getMap('map' + $scope.id).then(function(map) {
					var myBounds = new L.LatLngBounds($scope.map.markers);
					map.fitBounds(myBounds,{padding: [50,50]});
				});

			}

		}, function(err) {
			checkYourInternet();
		});
	};
}]);
